<?php

/**
 * @package     Sprinix_MultiTax
 * @copyright   Copyright (c) 2023 Sprinix Technolabs pvt Ltd.. (https://www.sprinix.com)
 */
namespace Sprinix\MultiTax\Model\Invoice\Total;
use Magento\Sales\Model\Order\Invoice\Total\AbstractTotal;
use Magento\Sales\Model\Order\Invoice;

/**
 * Class Fee
 * @package Sprinix\MultiTax\Model\Invoice\Total
 */
class Fee extends AbstractTotal
{
    /**
     * @param Invoice $invoice
     * @return $this|AbstractTotal
     */
    public function collect(Invoice $invoice)
    {
        $amount = 0;
        $orderTable = json_decode($invoice->getOrder()->getPaymentFee(),true);
        if ($orderTable) {
            if (($invoice->getOrder()->getInvoiceCollection()->getSize()) == null) {
                foreach ($orderTable as $key => $value) {
                    $price['price'][] = $value['price'];
                    $type['type'][] = $value['type'];
                    $amount += $value['price'];
                }
                $invoice->setPaymentFee($amount);
                $invoice->setGrandTotal($invoice->
                    getGrandTotal() + $invoice->getPaymentFee());
                $invoice->setBaseGrandTotal($invoice->
                    getBaseGrandTotal() + $invoice->getPaymentFee());
            }
        }
        return $this;
    }
}
