<?php

/**
 * @package     Sprinix_MultiTax
 * @copyright   Copyright (c) 2023 Sprinix Technolabs pvt Ltd.. (https://www.sprinix.com)
 */
namespace Sprinix\MultiTax\Model\CreditMemo\Total;
use Magento\Sales\Model\Order\Creditmemo\Total\AbstractTotal;
use Magento\Sales\Model\Order\Creditmemo;

/**
 * Class Fee
 * @package Sprinix\MultiTax\Model\CreditMemo\Total
 */
class Fee extends AbstractTotal
{
    /**
     * @param Creditmemo $creditmemo
     * @return $this|AbstractTotal
     */
    public function collect(Creditmemo $creditmemo)
    {
        $amount = 0;
        $orderTable = json_decode($creditmemo->getOrder()->getPaymentFee(),true);
        if ($orderTable) {
            if (($creditmemo->getOrder()->getInvoiceCollection()->getSize()) == null) {
                foreach ($orderTable as $key => $value) {
                    $price['price'][] = $value['price'];
                    $type['type'][] = $value['type'];
                    $amount += $value['price'];
                }
                $creditmemo->setPaymentFee($amount);
                $creditmemo->setGrandTotal($creditmemo->
                    getGrandTotal() + $creditmemo->getPaymentFee());
                $creditmemo->setBaseGrandTotal($creditmemo->
                    getBaseGrandTotal() + $creditmemo->getPaymentFee());
                return $this;
            }
        }
        return $this;
    }
}
